/** Class contains info for each agent.
 * Class also has method for instantiating agents and
 * agent decision making.
 *
 * @author Jason Harburger
 * jasonharburger@hotmail.com
 * 
 * 10/8/01
 * 
 */

import java.io.*;
import java.util.Random;
import java.math.*;

public class Agent{
	
	//if AddErrorTermToNews term is true then updating expectations looks like
	//expectation = news + random_error
	public static final boolean AddErrorTermToNews=false;
	
	//new agents initial inflation expectation of 2.0937 percent, corresponding to actual inflation in 1960q1
    //and time of last update equals zero
    public float InflationExpectation = (float) 2.0937; 
    public int   TimeOfLastUpdate     = 0;	
    public int   DistanceToNearestNewsSource = 0;
	
	//probability that an agent who is not a news agent
	//gets the most recent info from the common source if we're doing a sim with common source updating
	public double CommonUpdateProb;

    //generates random numbers (uniform dist)  
	private static Random rand =new Random();  
	
	//if an agent shares a geographic space with a news location
	public boolean getsNews = false;	
	
	//buddy_locale records the position of an agent in Moore neighborhood
	//who is closer to news source and shares info
	int[] buddy_locale=new int[2];	
	
	int updatedThisPeriod;  // 0 or 1 variable indicating whether this agent updates in the current period
	/**constructor
	 */
	public Agent(float lambdaMinInput, float lambdaMaxInput) {

		//set updating probability as a uniform random number between lambdaMin and lambdaMax
		CommonUpdateProb=(new Double(((lambdaMaxInput+lambdaMinInput)/2)+(rand.nextDouble()-0.5)*(lambdaMaxInput-lambdaMinInput))).floatValue();	

	}

	/** Updates the agent to the current news forecast.
	 * @param PublicNewsForecast actual news forecast in a given period
	*/
	public void updateCommon(int TimeOfPublicForecast, float PublicForecastPlusError) {
			TimeOfLastUpdate    = TimeOfPublicForecast;
			InflationExpectation= PublicForecastPlusError;		
	}
		
		//code not in use yet
		//if(distSlowsNews==false){  		
		//	if (rand.nextFloat()<=CommonUpdateProb){
		//		TimeOfLastUpdate=time;
		//		InflationExpectation=PublicNewsForecast;		
        //        }
		//}
		//if(distSlowsNews==true){}
	
	/*
	  /**Determines if agent gets updated.
	 * @param PublicNewsForecast actual forecast rate in a given period
	 */
	public void updateFromNeighbor(int time, float PublicNewsForecast, float NeighborNewsPlusError){
			updatedThisPeriod   =1;
			TimeOfLastUpdate    =time;
			InflationExpectation=NeighborNewsPlusError;		
			
	}
	
	public void setDist(int distance_from_news){
		DistanceToNearestNewsSource=distance_from_news;
	}
	
	public void setBuddy(int[] coord){
		buddy_locale[0]=coord[0];
		buddy_locale[1]=coord[1];
	
	}
	
}//class Agent





